{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}



    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            //Client:{routeName:'BaseController-getComboValues',table:'clients'}
            MouldGroup:{routeName:'ClientMouldGroup-getComboValues-special',table:'mould_groups',options:{where:''}}
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);

            const gridConfig = {
                cm: [
                    {header: "{{ 'ClientMouldGroup.client'|trans }}", dataIndex: 'code', width: 250,filter:'single',alias:'c',operator:'%.%'}
                ]
            };

            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    }),
                    new mj.form.combo({
                        title: "{{ 'ClientMouldGroup.client'|trans }}",
                        placeHolder: "{{ 'ClientMouldGroup.client_placeholder'|trans }}",
                        dataIndex: 'client',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        labelWidth : '90px',
                        grid: 's6 m4',
                        width : 150,
                        store: t.extras.clients
                    })
                ]
            };
            t._setFormConfig(formConfig);
            t.win.on('afterresize',function(){
                t.southLayout.doLayout();
            });
        },
        _setFormConfig:function(formConfig){
            const t = this;
            t.stores.form = new mj.store({failure:function(a,b){
				//console.log(a);
                //console.log(b);
                t.waitMaskHide();
			}});
            t.stores.form.on('load', t._onFormStoreLoad, t);
    
            t.forms = {};
            t.panel=new mj.panel({
                renderTo : t.tabs.main.form.getBody(),
                border : false,
                buttons:[
                    {
                        alt: mj.lng.glb.save,
                        cls: 'btn-sm left',
                        iconCls: 'mj-save',
                        //invisible: true,
                        scope: t,
                        handler: t._onButtonFormSubmitClick
                    },
                    {
                        alt: mj.lng.glb.cancel,
                        cls: 'btn-sm left',
                        iconCls: 'mj-list',
                        //invisible: true,
                        scope: t,
                        handler: t._onButtonFormCancelClick
                    }
                ]
            });
            t.windowButtons.formSubmit=false;
            t.windowButtons.formCancel=false;
            
            t.layout = new mj.layout({
                renderTo : t.panel.getBody(),
                layout : 'border',
                items : [
                    {
                        region  : 'north',
                        initial : 40,
                        min : 40,
                        max : 40,
                        split: false,
                        collapsible : false,
                        collapsed : false
                    }
                ]
            });
            
            t.southLayout = new mj.layout({
                renderTo : mj.NE(t.layout.getBody('center')),
                layout : 'border',
                items : [
                    {
                        region  : 'west',
                        initial : 600,
                        min : 600,
                        max : 600,
                        split: false,
                        collapsible : false,
                        collapsed : false
                    }
                ]
            });

            t.forms.main = new mj.form(mj.apply({
                renderTo: t.layout.getBody('north'),//t.tabs.main.form.getBody(),
                modulename: t.modulename,
                store: t.stores.form,
                buttonPos:false
            }, formConfig));
            
            t.initDefaultButtons();
            t.buttons.formSubmit = t.panel.buttons[0];
            t.buttons.formCancel = t.panel.buttons[1];

            t.winAddChildRecord = new mj.window({
                renderTo : mj.NE(),
                title : '',
                modal : true,
                width : 400,
                height : 300,
                minWidth : 400,
                minHeight : 300,
                buttons : [
                    {title: mj.lng.glb.exit, handler:function(){t.winAddChildRecord.hide();}},
                    {title: mj.lng.glb.save}
                ]
            });
            
            t.win.addRelated(t.winAddChildRecord);
            
            t.forms.childRecords = new mj.form({
                renderTo : t.winAddChildRecord.getBody(),
                store : new mj.store({}),
                buttonPos:false
            });

            t.grids.groups = new mj.grid({
                win: t.win,
                renderTo: t.southLayout.getBody('west'),
                store: [],
                pbar: new mj.pager({defaultButtons:false,elements: {selectLimit:false}, limit:null}),
                fitToParent: true,
                cm : [
                    {header: mj.lng.glb.id, dataIndex: 'id', width:5, align:'right',hide:true},
                    {header: "", dataIndex: 'client', width: 5,hide:true},
                    {header: "{{ 'ClientMouldGroup.code'|trans }}", dataIndex: 'code', width: 150},
                    {header: "{{ 'ClientMouldGroup.productionmultiplier'|trans }}", dataIndex: 'productionmultiplier', align:'right', width: 60},
                    {header: "{{ 'ClientMouldGroup.intervalmultiplier'|trans }}", dataIndex: 'intervalmultiplier', align:'right', width: 60},
                    {header: "{{ 'ClientMouldGroup.setup'|trans }}", dataIndex: 'setup', align:'right', width: 60},
                    {header: "{{ 'ClientMouldGroup.cycletime'|trans }}", dataIndex: 'cycletime', align:'right', width: 65},
                    {header: "{{ 'ClientMouldGroup.lotcount'|trans }}", dataIndex: 'lotcount', align:'right', width: 60},
                    {header: "{{ 'ClientMouldGroup.operatorcount'|trans }}", dataIndex: 'operatorcount', align:'right', width: 60},
					{header: "{{ 'ClientMouldGroup.isdefault'|trans }}", dataIndex: 'isdefault', width: 60,renderer:mj.renderer.check()},
                    {header: '', width: 5,hide:true}
                ]
            });
            t.grids.groups.on('rowclick',function(g,s){
                var d = g.selectedRow.data;
                if(d._details&&d._details.length>0){
                    t.grids.details.store.data = d._details;
                }else{
                    t.grids.details.store.data=[];
                }
                t.grids.details.load();
                t.buttons['addBtndetails'].setEnable();
            });
            t.grids.details = new mj.grid({
                win: t.win,
                renderTo: t.southLayout.getBody('center'),
                store: [],
                pbar: new mj.pager({defaultButtons:false,elements: {selectLimit:false}, limit:null}),
                fitToParent: true,
                cm : [
                    {header: mj.lng.glb.id, dataIndex: 'id', width:5, align:'right',hide:true},
                    {header: "", dataIndex: 'client', width: 5,hide:true},
                    {header: "", dataIndex: 'clientmouldgroup', width: 5,hide:true},
                    {header: "{{ 'ClientMouldGroup.mouldgroup'|trans }}", dataIndex: 'mouldgroup', width: 250},
                    {header: '', width: 5,hide:true}
                ]
            });

            for(var item in t.grids){
                if(item!='main'){
                    t.buttons['addBtn'+item] = t.grids[item].pbar.tbar.addButton({id:'btnAddTable',alt:mj.lng.glb.add, iconCls : 'mj-add', disabled: true, handler : t.addChildRecordHandler,scope:{scope:t,grid:t.grids[item],item:item,mode:'add'}});
                    t.buttons['editBtn'+item] = t.grids[item].pbar.tbar.addButton({id:'btnEdit',alt:mj.lng.glb.edit,iconCls :'mj-edit', disabled:true, handler:t.editChildRecordHandler,scope:{scope:t,grid:t.grids[item],item:item,mode:'edit'}});
                    t.buttons['deleteBtn'+item] = t.grids[item].pbar.tbar.addButton({id:'btnDeleteTable',alt:mj.lng.glb.del, iconCls : 'mj-delete', disabled: true, handler:t.deleteChildRecordHandler,scope:{scope:t,grid:t.grids[item],item:item}});
                    t.grids[item].on('rowclick',function(g,s){
                        t.buttons['editBtn'+this].setEnable();
                        t.buttons['deleteBtn'+this].setEnable();
                    },item);
                    t.grids[item].on('rowdblclick',function(g,s){
                        this.handler.call(this.scope);
                    },t.buttons['editBtn'+item]);
                    t.grids[item].store.on('load',function(){
                        t.btnChildDisabler(this);
                        t.buttons['addBtngroups'].setEnable();
                        if(item==='details'){
                            t.buttons['addBtndetails'].setEnable();
                        }
                    },item);
                    t.grids[item].load();
                }
            }
        },
        formCreator : function(g,i,m){
            var t=this;
            t.forms.childRecords.removeAll();
            switch (i){
                case 'details':
                    t.stores.MouldGroup=false;
                    var _itemStore=t.storeConfig.MouldGroup;
                    _itemStore.options.where=t.forms.main.items[2].getValue();
                    var _routeName = _itemStore.routeName;
                    var _route = Routing.getRoute(_routeName);
                    var _data = {
                        'pg': 1,
                        'lm': t.recordsperpage,
                        'table':_itemStore.table,
                        'fieldId':(_itemStore.fieldId?_itemStore.fieldId:'code'),
                        'fieldDisplay':(_itemStore.fieldDisplay?_itemStore.fieldDisplay:'code')
                    };
                    if(_itemStore.options){
                        _data.options=JSON.stringify(_itemStore.options);
                    }
                    var _url = Routing.generate(_routeName, _data);
                    t.stores.MouldGroup=new mj.store({
                        url: _url,
                        method: _route.requirements._method,
                        modulename:_itemStore.modulename?_itemStore.modulename:t.modulename,
                        routename:_routeName,
                        routedata:_data
                    });
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : mj.lng.glb.id,
                            dataIndex : 'id',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            hidden:true,
                            width : 50
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.textField({
                            title : "client",
                            dataIndex : 'client',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 150,
                            hidden : true,
                            value : (m!='add'?t.forms.main.items[0].getValue():''),
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.textField({
                            title : "clientmouldgroup",
                            dataIndex : 'clientmouldgroup',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 150,
                            hidden : true,
                            value : (m!='add'?t.grids.groups.selectedRow.data.clientmouldgroup:''),
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.combo({
                            title : "{{ 'ClientMouldGroup.mouldgroup'|trans }}",
                            dataIndex : 'mouldgroup',
                            mode : 'remote',
                            store : t.stores.MouldGroup,
                            width : 200,
                            labelWidth : '130px',
                            itemStyle : 'padding-top:5px;',
                            notEmpty : true
                        })
                    );
                    break;	
                case 'groups':
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : mj.lng.glb.id,
                            dataIndex : 'id',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            hidden:true,
                            width : 50
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.textField({
                            title : "client",
                            dataIndex : 'client',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 150,
                            hidden : true,
                            value : (m!='add'?t.forms.main.items[0].getValue():''),
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.textField({
                            title : "{{ 'ClientMouldGroup.code'|trans }}",
                            dataIndex : 'code',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 150,
                            notEmpty : true
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : "{{ 'ClientMouldGroup.productionmultiplier'|trans }}",
                            dataIndex : 'productionmultiplier',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            maxLength: 3,
                            width : 50
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : "{{ 'ClientMouldGroup.intervalmultiplier'|trans }}",
                            dataIndex : 'intervalmultiplier',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            money : true,
                            suffix : '',
                            decimalPrecision : 2,
                            decimalPrecisionReal : 2,
                            defaultZero : false,
                            width : 50
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : "{{ 'ClientMouldGroup.setup'|trans }}",
                            dataIndex : 'setup',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 50
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : "{{ 'ClientMouldGroup.cycletime'|trans }}",
                            dataIndex : 'cycletime',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            money : true,
                            suffix : '',
                            decimalPrecision : 4,
                            decimalPrecisionReal : 4,
                            defaultZero : false,
                            width : 50
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : "{{ 'ClientMouldGroup.lotcount'|trans }}",
                            dataIndex : 'lotcount',
                            maxLength: 5,
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 50
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : "{{ 'ClientMouldGroup.operatorcount'|trans }}",
                            dataIndex : 'operatorcount',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            maxLength: 2,
                            width : 50
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.checkBox({
                            title: "{{ 'ClientMouldGroup.isdefault'|trans }}",
                            dataIndex: 'isdefault',
                            itemStyle : 'padding-top:5px;',
                            labelWidth : '110px',
                            grid: 'none'
                        })
                    );
            }
            if(m == 'edit'){
                t.forms.childRecords.store.data = g.selectedRow.data;
                t.forms.childRecords.load();
            }
        },
        saveChildRecord : function(){
            var t = this.scope, g = this.grid, m = this.mode, item = this.item, _err = false;
            var d =  t.forms.childRecords.getValue();
            if(item=='groups'){
                //if(typeof d.code=='undefined'||d.code==''){
                //    _err = true;
                //    t.forms.childRecords.items[2].markInvalid();
                //    t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                //}
            }else{
                //t.forms.childRecords.items[1].clearInvalid();
                //if(typeof d.leafId=='undefined'||d.leafId==''){
                //    _err = true;
                //    t.forms.childRecords.items[1].markInvalid();
                //    t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                //}
                //if((typeof d.leafmask=='undefined'||d.leafmask==''||parseInt("0"+d.leafmask)==0)&&!_err){
                //    _err = true;
                //    t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                //}
            }
            if(!_err){
                if(m == 'edit'){
                    d._details = g.store.data[g.selectedRow.index]._details;
                    g.store.data[g.selectedRow.index] = d;
                }else{
                    if(item==='groups'){
                        d._details = [];
                    }
                    g.store.data.push(d);
                    if(item!=='groups'){
                        t.grids.groups.selectedRow.data._details=g.store.data;
                    }
                }
                g.load();
                t.winAddChildRecord.hide();
            }
        },
        windowSetHandler : function(g,i,m){
            var t=this;
            t.winAddChildRecord.setTitle(m=='add'?mj.lng.glb.addRecord:mj.lng.glb.editRecord);
            t.winAddChildRecord.buttons[1].setHandler(t.saveChildRecord,{scope:t,grid:g,mode:m,item:i});
            t.formCreator(g,i,m);
        },        
        addChildRecordHandler : function(){
            var t = this.scope, g = this.grid, item = this.item, m = this.mode;
            if(item=='groups'){
                t.grids.groups.clearSelectedRow();
                t.grids.details.store.data = [];
                t.grids.details.load();
                t.buttons['addBtndetails'].setDisable();
            }
            t.windowSetHandler(g,item,m);
            t.winAddChildRecord.show();
        },
        editChildRecordHandler : function(){
            var t = this.scope, g = this.grid, item = this.item, m = this.mode;
            t.windowSetHandler(g,item,m);
            t.winAddChildRecord.show();
        },
        deleteChildRecordHandler : function(){
            var t = this.scope, g = this.grid, item = this.item, m = this.mode;
            new mj.message({
                title:mj.lng.glb.onay,
                modal : true,
                msg:mj.lng.glb.delQuestion,
                buttons:['NO','YES'],
                cb:function(el,btn){
                    if(btn=='YES'){
                        if(typeof g.store.data[g.selectedRow.index]._details=='object'&&item=='groups'){
                            t.grids.details.store.data = [];
                            t.grids.details.load();
                            t.buttons['addBtndetails'].setDisable();
                        }
                        g.store.data.remove(g.store.data[g.selectedRow.index]);
                        g.load();
                        if(item==='details'){
                            t.buttons['addBtndetails'].setEnable();
                        }
                    }
                    el.window.close();
                }
            });
        },
        btnChildDisabler:function(item){
            var btns = this.buttons;
            if(btns['addBtn'+item]&&typeof btns['addBtn'+item].setDisable == 'function')
                btns['addBtn'+item].setDisable();
            if(btns['editBtn'+item]&&typeof btns['editBtn'+item].setDisable == 'function')
                btns['editBtn'+item].setDisable();
            if(btns['deleteBtn'+item]&&typeof btns['deleteBtn'+item].setDisable == 'function')
                btns['deleteBtn'+item].setDisable();
        },
        _onButtonAddClick:function(){
            var t=this;
            t.grids.groups.store.data=[];
            t.grids.groups.load();
            t.grids.details.store.data = [];
            t.grids.details.load();
            t.newRecord();
        },
        _onFormStoreLoad:function(store){
            var t=this;
            if(store.recordCount>0){
                store.data=store.data[0];
                t.forms.main.loadForm();
                t.grids.groups.store.data=store.data._groups;
                t.grids.groups.load();
                t.grids.details.store.data = [];
                t.grids.details.load();
                t.activateTabForm();
                t.waitMaskHide();
            }
        },
        editData:function(data){
            var t=this;
            var routeName = t.modulename + '-show';
            var route = Routing.getRoute(routeName);
            var data = {
                'id': data.id,
                'menuId': t.id
            };
            var url = Routing.generate(routeName, data);
            this.forms.main.store.modulename=t.modulename;
            this.forms.main.store.url=url;
            this.forms.main.store.method= route.methods[0];
            this.forms.main.store.load();
            t.waitMaskShow();
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            if (f.modulename && typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    var id = f.getValue('id').id;
                    var versionField = f.getField('version');
                    var version = typeof versionField != "undefined" ? f.getValue('version').version : 0;
                    var mode = id ? 'update' : 'add';
                    var routeName = f.modulename + '-' + mode;
                    var route = Routing.getRoute(routeName);
                    var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                        'pg': t.grids.main.pbar.current,
                        'lm': t.grids.main.pbar.limit
                    } : {};
                    var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                        'id': id,
                        'v': version
                    }) : pagerParams);
                    var data = f.getValue();
                    data.menuId = t.id;
                    data.groups=t.grids.groups.store.data;
                    if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                        t.waitMaskShow();
                        t._event='save';
                        $.ajax({
                            url: url,
                            method: "POST",
                            data: JSON.stringify(data),
                            headers: { 
                                "Content-Type": "application/json",
                                "X-HTTP-Method-Override": route.methods[0] 
                            },
                            dataType: 'json',
                            success: function(data, textStatus, jqXHR) {
                                t.reset(_f, data);
                                //t.activateTabGrid();
                                //t.waitMaskHide();
                            },
                            error: function(jqXHR, textStatus, errorThrown) {
                                t.waitMaskHide();
                                mj.message({
                                    title: mj.lng.glb.error,
                                    msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                    type: "error",
                                    html: true
                                });
                            },
                            complete: function(jqXHR, textStatus) {
                                //t.waitMaskHide();
                            }
                        });
                    }
                //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
